library IEEE; 
use IEEE.std_logic_1164.all;


entity add_2_cla is
  port(
    A, B    : in  std_logic_vector (1 downto 0);
    Z       : out std_logic_vector (2 downto 0));
end add_2_cla;

architecture add_2_cla_arc of add_2_cla is

component FA
	port ( A, B, carry_in : in std_logic;
	       F,   carry_out : out std_logic
	);
end component;

signal
	c0,
	a1_and_b1,
	a1_or_b1,
	a1_or_b1_and_c0,
	useless : std_logic;

begin
	FA_0: FA port map(A(0)    ,B(0)     ,'0'            ,Z(0),c0);
	FA_1: FA port map(A(1)    ,B(1)     ,c0             ,Z(1));
	FA_2: FA port map('1'     ,A(1)     ,B(1)           ,useless,a1_or_b1);
	FA_3: FA port map(A(1)    ,B(1)     ,'0'            ,useless,a1_and_b1);
	FA_4: FA port map(a1_or_b1,c0       ,'0'            ,useless,a1_or_b1_and_c0);
	FA_5: FA port map('1'     ,a1_and_b1,a1_or_b1_and_c0,useless,Z(2));
end add_2_cla_arc;