library IEEE; 
use IEEE.std_logic_1164.all;


entity add_4_pipe is
  port(
    A, B    : in  std_logic_vector (3 downto 0);
    Z       : out std_logic_vector (4 downto 0);
    clk     : in std_logic);
end add_4_pipe;

architecture add_4_pipe_arc of add_4_pipe is

component FA
	port ( A, B, carry_in : in std_logic;
	       F,   carry_out : out std_logic
	);
end component;
component bit_reg
	port (  clk,d_in: in std_logic;
		d_out: out std_logic);
end component;

signal	reg1_reg3,reg3_reg7,reg7_fa,
	reg2_reg4,reg4_reg8,reg8_fa,
	reg5_reg9,reg9_fa,
	reg6_reg10,reg10_fa,
	reg11_fa,
	reg12_fa,
	co_reg15,reg15_cin,
	co_reg14,reg14_cin,
	co_reg13,reg13_cin,
	co_reg22,
	s_reg16,reg16_reg18,reg18_reg21,reg21_reg26,
	s_reg17,reg17_reg20,reg20_reg25,
	s_reg19,reg19_reg24,
	s_reg23 : std_logic;

begin
	FA_0: FA port map(A(0)    ,B(0)    ,'0'      ,s_reg16,co_reg15);
	FA_1: FA port map(reg11_fa,reg12_fa,reg15_cin,s_reg17,co_reg14);
	FA_2: FA port map(reg9_fa ,reg10_fa,reg14_cin,s_reg19,co_reg13);
	FA_3: FA port map(reg7_fa ,reg8_fa ,reg13_cin,s_reg23,co_reg22);
 
	reg_01: bit_reg port map (clk, B(3)      , reg1_reg3);
	reg_02: bit_reg port map (clk, A(3)      , reg2_reg4);
	reg_03: bit_reg port map (clk, reg1_reg3 , reg3_reg7);
	reg_04: bit_reg port map (clk, reg2_reg4 , reg4_reg8);
	reg_05: bit_reg port map (clk, B(2)      , reg5_reg9);
	reg_06: bit_reg port map (clk, A(2)      , reg6_reg10);
	reg_07: bit_reg port map (clk, reg3_reg7 , reg7_fa);
	reg_08: bit_reg port map (clk, reg4_reg8 , reg8_fa);
	reg_09: bit_reg port map (clk, reg5_reg9 , reg9_fa);
	reg_10: bit_reg port map (clk, reg6_reg10, reg10_fa);
	reg_11: bit_reg port map (clk, B(1)      , reg11_fa);
	reg_12: bit_reg port map (clk, A(1)      , reg12_fa);

	reg_13: bit_reg port map (clk, co_reg13  , reg13_cin);
	reg_14: bit_reg port map (clk, co_reg14  , reg14_cin);
	reg_15: bit_reg port map (clk, co_reg15  , reg15_cin);

	reg_16: bit_reg port map (clk, s_reg16     , reg16_reg18);
	reg_17: bit_reg port map (clk, s_reg17     , reg17_reg20);
	reg_18: bit_reg port map (clk, reg16_reg18 , reg18_reg21);
	reg_19: bit_reg port map (clk, s_reg19     , reg19_reg24);
	reg_20: bit_reg port map (clk, reg17_reg20 , reg20_reg25);
	reg_21: bit_reg port map (clk, reg18_reg21 , reg21_reg26);
	reg_22: bit_reg port map (clk, co_reg22    , Z(4));
	reg_23: bit_reg port map (clk, s_reg23     , Z(3));
	reg_24: bit_reg port map (clk, reg19_reg24 , Z(2));
	reg_25: bit_reg port map (clk, reg20_reg25 , Z(1));
	reg_26: bit_reg port map (clk, reg21_reg26 , Z(0));
	
end add_4_pipe_arc;