library IEEE;
use IEEE.std_logic_1164.all;
entity testbench is
  generic (CLK_CYCLE : time := 56 ns);  -- set this parameter to the 
end testbench;

architecture arc_testbench of testbench is
  component add_4_pipe is
  port (
    A,B     : in  std_logic_vector (3 downto 0);
    Z       : out std_logic_vector (4 downto 0);
    clk     : in std_logic);
  end component;
  signal A,B : std_logic_vector (3 downto 0);
  signal Z   : std_logic_vector (4 downto 0);
  signal clk : std_logic := '0';        -- clk signal, reset to '0' on
                                        -- simulation start.

 begin  
   UUT: component add_4_pipe port map (A,B,Z,clk);  --Unit Under Test
      
   process
   begin
     wait until ( (clk'event) and (clk = '1') );
     wait for 15 ns;                    --simulate the input registers.
     A <= "1010";
     B <= "1011";
     wait until ( (clk'event) and (clk = '1') );
     wait for 15 ns;                    --simulate the input registers.
     A <= "1000";
     B <= "0010";
     wait until ( (clk'event) and (clk = '1') );
     wait for 15 ns;                    --simulate the input registers.
     A <= "0100";
     B <= "0010";
     wait until ( (clk'event) and (clk = '1') );
     wait for 15 ns;                    --simulate the input registers.
     A <= "1100";
     B <= "0011";
         wait;                              
   end process;

   process
   begin
     wait for CLK_CYCLE/2;
     clk <= not clk;
   end process;
       
end arc_testbench; 

configuration cfg_testbench of testbench is
  for arc_testbench

    for UUT : add_4_pipe
      use entity work.add_4_pipe;
    end for;

  end for;
end cfg_testbench;
