library IEEE;
use IEEE.std_logic_1164.all;


entity testbench is
  generic (Tpd : time := 160 ns);  -- set this parameter to the latency of
                                  -- your design.
end testbench;


architecture arc_testbench of testbench is
  component add_4 
    port (
      A, B    : in  std_logic_vector (3 downto 0);
      Z       : out std_logic_vector (4 downto 0) );
  end component;
  
  signal A,B : std_logic_vector (3 downto 0);
  signal Z   : std_logic_vector (4 downto 0);

begin  -- arc_testbench

  UUT: component add_4 port map (A,B,Z);  --Unit Under Test
  
  process
  begin
    A <= "1010";
    B <= "1011";
    wait for Tpd;

    A <= "0001";
    B <= "1001";

    wait for Tpd;
    
    A <= "1111";
    B <= "0000";

    wait;                -- needed to prevent entering the process again.
  end process;
end arc_testbench; 

configuration cfg_testbench of testbench is
  for arc_testbench

    for UUT : add_4
      use entity work.add_4;
    end for;

  end for;
end cfg_testbench;
