library IEEE;
use IEEE.std_logic_1164.all;

entity mux_2_testbench is
end mux_2_testbench;

architecture behavioral of mux_2_testbench is
	component mux_2
		port ( A, B : in  std_logic_vector (1 downto 0);
		       C_in : in std_logic;
		       F    : out std_logic_vector (1 downto 0)
		);
	end component;
	
	signal in1,in2,testout:std_logic_vector (1 downto 0);
	signal sel:std_logic;
	
begin
	u1: mux_2 port map (in1,in2,sel,testout);
	process
		variable err_cnt: integer := 0;
	begin
	
		in1 <= "00";
		in2 <= "11";
		sel <='0';
		wait for 10ns;	
		assert(testout = "00") report "Error" severity error;
		if (testout /= "00") then
			err_cnt := err_cnt + 1;
		end if;
		sel <='1';
		wait for 10ns;	
		assert(testout = "11") report "Error" severity error;
		if (testout /= "11") then
			err_cnt := err_cnt + 1;
		end if;
		
	end process;

end behavioral;
